CfnTargetGroup L1 construct
Creates a target group.
A target group is a collection of targets, or compute resources, that run your application or service. A target group can only be used by a single service.
For more information, see Target groups in the Amazon VPC Lattice User Guide .
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_vpclattice as vpclattice } from 'aws-cdk-lib';
const cfnTargetGroup = new vpclattice.CfnTargetGroup(this, 'MyCfnTargetGroup', {
type: 'type',
// the properties below are optional
config: {
healthCheck: {
enabled: false,
healthCheckIntervalSeconds: 123,
healthCheckTimeoutSeconds: 123,
healthyThresholdCount: 123,
matcher: {
httpCode: 'httpCode',
},
path: 'path',
port: 123,
protocol: 'protocol',
protocolVersion: 'protocolVersion',
unhealthyThresholdCount: 123,
},
ipAddressType: 'ipAddressType',
lambdaEventStructureVersion: 'lambdaEventStructureVersion',
port: 123,
protocol: 'protocol',
protocolVersion: 'protocolVersion',
vpcIdentifier: 'vpcIdentifier',
},
name: 'name',
tags: [{
key: 'key',
value: 'value',
}],
targets: [{
id: 'id',
// the properties below are optional
port: 123,
}],
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_vpclattice as vpclattice
cfn_target_group = vpclattice.CfnTargetGroup(self, "MyCfnTargetGroup",
type="type",
# the properties below are optional
config=vpclattice.CfnTargetGroup.TargetGroupConfigProperty(
health_check=vpclattice.CfnTargetGroup.HealthCheckConfigProperty(
enabled=False,
health_check_interval_seconds=123,
health_check_timeout_seconds=123,
healthy_threshold_count=123,
matcher=vpclattice.CfnTargetGroup.MatcherProperty(
http_code="httpCode"
),
path="path",
port=123,
protocol="protocol",
protocol_version="protocolVersion",
unhealthy_threshold_count=123
),
ip_address_type="ipAddressType",
lambda_event_structure_version="lambdaEventStructureVersion",
port=123,
protocol="protocol",
protocol_version="protocolVersion",
vpc_identifier="vpcIdentifier"
),
name="name",
tags=[CfnTag(
key="key",
value="value"
)],
targets=[vpclattice.CfnTargetGroup.TargetProperty(
id="id",
# the properties below are optional
port=123
)]
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.vpclattice.*;
CfnTargetGroup cfnTargetGroup = CfnTargetGroup.Builder.create(this, "MyCfnTargetGroup")
.type("type")
// the properties below are optional
.config(TargetGroupConfigProperty.builder()
.healthCheck(HealthCheckConfigProperty.builder()
.enabled(false)
.healthCheckIntervalSeconds(123)
.healthCheckTimeoutSeconds(123)
.healthyThresholdCount(123)
.matcher(MatcherProperty.builder()
.httpCode("httpCode")
.build())
.path("path")
.port(123)
.protocol("protocol")
.protocolVersion("protocolVersion")
.unhealthyThresholdCount(123)
.build())
.ipAddressType("ipAddressType")
.lambdaEventStructureVersion("lambdaEventStructureVersion")
.port(123)
.protocol("protocol")
.protocolVersion("protocolVersion")
.vpcIdentifier("vpcIdentifier")
.build())
.name("name")
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.targets(List.of(TargetProperty.builder()
.id("id")
// the properties below are optional
.port(123)
.build()))
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.VpcLattice;
var cfnTargetGroup = new CfnTargetGroup(this, "MyCfnTargetGroup", new CfnTargetGroupProps {
Type = "type",
// the properties below are optional
Config = new TargetGroupConfigProperty {
HealthCheck = new HealthCheckConfigProperty {
Enabled = false,
HealthCheckIntervalSeconds = 123,
HealthCheckTimeoutSeconds = 123,
HealthyThresholdCount = 123,
Matcher = new MatcherProperty {
HttpCode = "httpCode"
},
Path = "path",
Port = 123,
Protocol = "protocol",
ProtocolVersion = "protocolVersion",
UnhealthyThresholdCount = 123
},
IpAddressType = "ipAddressType",
LambdaEventStructureVersion = "lambdaEventStructureVersion",
Port = 123,
Protocol = "protocol",
ProtocolVersion = "protocolVersion",
VpcIdentifier = "vpcIdentifier"
},
Name = "name",
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} },
Targets = new [] { new TargetProperty {
Id = "id",
// the properties below are optional
Port = 123
} }
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnTargetGroup := awscdk.Aws_vpclattice.NewCfnTargetGroup(this, jsii.String("MyCfnTargetGroup"), &CfnTargetGroupProps{
Type: jsii.String("type"),
// the properties below are optional
Config: &TargetGroupConfigProperty{
HealthCheck: &HealthCheckConfigProperty{
Enabled: jsii.Boolean(false),
HealthCheckIntervalSeconds: jsii.Number(123),
HealthCheckTimeoutSeconds: jsii.Number(123),
HealthyThresholdCount: jsii.Number(123),
Matcher: &MatcherProperty{
HttpCode: jsii.String("httpCode"),
},
Path: jsii.String("path"),
Port: jsii.Number(123),
Protocol: jsii.String("protocol"),
ProtocolVersion: jsii.String("protocolVersion"),
UnhealthyThresholdCount: jsii.Number(123),
},
IpAddressType: jsii.String("ipAddressType"),
LambdaEventStructureVersion: jsii.String("lambdaEventStructureVersion"),
Port: jsii.Number(123),
Protocol: jsii.String("protocol"),
ProtocolVersion: jsii.String("protocolVersion"),
VpcIdentifier: jsii.String("vpcIdentifier"),
},
Name: jsii.String("name"),
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
Targets: []interface{}{
&TargetProperty{
Id: jsii.String("id"),
// the properties below are optional
Port: jsii.Number(123),
},
},
})
Initializer
new CfnTargetGroup(scope: Construct, id: string, props: CfnTargetGroupProps)
CfnTargetGroup(scope: Construct, id: str, props: CfnTargetGroupProps)
new CfnTargetGroup(Construct scope, String id, CfnTargetGroupProps props)
new CfnTargetGroup(Construct scope, string id, CfnTargetGroupProps props)
NewCfnTargetGroup(Scope Construct, Id *string, Props CfnTargetGroupProps)
Construct Props
configoptionalIResolvable | CfnTargetGroup.TargetGroupConfigPropertyconfigoptionaltyping.Union[IResolvable, TargetGroupConfigProperty]configoptionalIResolvableConfigoptionalIResolvableConfigoptionalinterface{}#notes
The name must be unique within the account. The valid characters are a-z, 0-9, and hyphens (-). You can't use a hyphen as the first or last character, or immediately after another hyphen.
If you don't specify a name, CloudFormation generates one. However, if you specify a name, and later want to replace the resource, you must specify a new name.
tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#targetsoptionalIResolvable | IResolvable | CfnTargetGroup.TargetProperty[]targetsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, TargetProperty]]]targetsoptionalIResolvableTargetsoptionalIResolvableTargetsoptionalinterface{}#Properties
attrLastUpdatedAtstringattr_last_updated_atstrattrLastUpdatedAtStringAttrLastUpdatedAtstringAttrLastUpdatedAt*string#You can retry the operation if the status is CREATE_FAILED . However, if you retry it while the status is CREATE_IN_PROGRESS , there is no change in the status.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptions#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#configmay be undefinedIResolvable | CfnTargetGroup.TargetGroupConfigPropertyconfigmay be undefinedtyping.Union[IResolvable, TargetGroupConfigProperty]configmay be undefinedIResolvableConfigmay be undefinedIResolvableConfigmay be undefinedinterface{}#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
namemay be undefinedstringnamemay be undefinedstrnamemay be undefinedStringNamemay be undefinedstringNamemay be undefined*string#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
CfnElements must be defined within a stack scope (directly or indirectly).
tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag#targetGroupRefTargetGroupReferencetarget_group_refTargetGroupReferencetargetGroupRefTargetGroupReferenceTargetGroupRefTargetGroupReferenceTargetGroupRefTargetGroupReference#targetsmay be undefinedIResolvable | IResolvable | CfnTargetGroup.TargetProperty[]targetsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, TargetProperty]]]targetsmay be undefinedIResolvableTargetsmay be undefinedIResolvableTargetsmay be undefinedinterface{}#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForTargetGroup(resource: ITargetGroupRef): string@staticmethod def arn_for_target_group(resource: ITargetGroupRef) -> strpublic static String arnForTargetGroup(ITargetGroupRef resource)public static string ArnForTargetGroup(ITargetGroupRef resource)func ArnForTargetGroup(Resource ITargetGroupRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isCfnTargetGroup(x: any): boolean@staticmethod def is_cfn_target_group(x: Any) -> boolpublic static Boolean isCfnTargetGroup(Object x)public static bool IsCfnTargetGroup(object x)func IsCfnTargetGroup(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.